// VCSampleDlg.cpp : implementation file
//

#include "stdafx.h"
#include "VCSample.h"
#include "VCSampleDlg.h"
#include "ConaitoObject.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CVCSampleDlg dialog

CVCSampleDlg::CVCSampleDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CVCSampleDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CVCSampleDlg)
	m_nListenPort = 32444;
	m_sSendClientText = _T("");
	m_sClientUniqueId = _T("");
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);

	m_pConaitoServer = new CConaitoObject;

}

void CVCSampleDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CVCSampleDlg)
	DDX_Control(pDX, IDC_LIST_REGISTERED_CLIENTS, m_sListRegisteredClients);
	DDX_Control(pDX, IDC_LIST_RECEIVE_CLIENT_TEXT, m_sReceiveClientText);
	DDX_Control(pDX, IDC_LIST_TEXT, m_ListMonitorText);
	DDX_Text(pDX, IDC_EDIT_LISTEN_PORT, m_nListenPort);
	DDX_Text(pDX, IDC_EDIT_SEND_MSG, m_sSendClientText);
	DDX_Text(pDX, IDC_EDIT_SEND_UNIQUEID, m_sClientUniqueId);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CVCSampleDlg, CDialog)
	//{{AFX_MSG_MAP(CVCSampleDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON_INITIALIZE, OnButtonInitialize)
	ON_BN_CLICKED(IDC_BUTTON_UNINITIALIZE, OnButtonUninitialize)
	ON_WM_DESTROY()
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_BUTTON_SEND_MSG, OnButtonSendMsg)
	ON_BN_CLICKED(IDC_BUTTON_SEND_MSG_TO_ALL, OnButtonSendMsgToAll)
	ON_BN_CLICKED(IDC_BUTTON_GET_UNIQUEIDSLIST, OnButtonGetUniqueidslist)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CVCSampleDlg message handlers

BOOL CVCSampleDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	
	SetTimer(0, 500, 0);

	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CVCSampleDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CVCSampleDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CVCSampleDlg::ErrorMessage()
{
	DWORD dwError = m_pConaitoServer->GetLastError();

	CWnd* pParentWnd = AfxGetMainWnd();
	
	if(dwError == 10)
	{
		pParentWnd->MessageBox("Proxy Server is not online, please click the 'Initialize' button first to receive the connections", "Online", MB_ICONEXCLAMATION);
	}

	else if(dwError == 11)
	{
		pParentWnd->MessageBox("Cannot open local communication port or Port is already in use", "Local Port Error", MB_ICONEXCLAMATION);
	}
	
	else if(dwError == 12)
	{
		pParentWnd->MessageBox("Provided Unique Id does not exist", "Unioque ID", MB_ICONEXCLAMATION);
	}
}

void CVCSampleDlg::OnButtonInitialize() 
{
	UpdateData();

	if(!m_pConaitoServer->Initialize(m_nListenPort))
	{
		ErrorMessage();
		return;
	}

	MessageBox("Voice Server is Initialized successfully", "Server is Running", MB_OK|MB_ICONEXCLAMATION);
	
}

void CVCSampleDlg::OnButtonUninitialize() 
{
	m_pConaitoServer->UnInitialize();
}

void CVCSampleDlg::OnDestroy() 
{
	
	KillTimer(0);
	
	CDialog::OnDestroy();
	
	m_pConaitoServer->UnInitialize();
	delete m_pConaitoServer;
	
}

void CVCSampleDlg::OnTimer(UINT nIDEvent) 
{
	
	DWORD dwDataRate = m_pConaitoServer->GetOutBoundDataRate();
	
	CWnd* pWnd = GetDlgItem(IDC_STATIC_OUTDATARATE);
	
	CString sDigit = _T("");
	sDigit.Format("%d", dwDataRate);
	
	pWnd->SetWindowText(sDigit);
	

	dwDataRate = m_pConaitoServer->GetInBoundDataRate();
	
	pWnd = GetDlgItem(IDC_STATIC_INDATARATE);
	
	sDigit = _T("");
	sDigit.Format("%d", dwDataRate);
	
	pWnd->SetWindowText(sDigit);
	


	dwDataRate = m_pConaitoServer->GetTotalRegisteredClient();
	
	pWnd = GetDlgItem(IDC_STATIC_REGCLIENTS);
	
	sDigit = _T("");
	sDigit.Format("%d", dwDataRate);
	
	pWnd->SetWindowText(sDigit);
	
	CDialog::OnTimer(nIDEvent);
}

void CVCSampleDlg::OnButtonSendMsg() 
{
	
	UpdateData();
		
	if(!m_pConaitoServer->SendTextMessageTo(m_sClientUniqueId, m_sSendClientText))
	{
		ErrorMessage();
	}

}

void CVCSampleDlg::OnButtonSendMsgToAll() 
{
	
	UpdateData();
		
	if(!m_pConaitoServer->SendTextMessageToAll(m_sSendClientText))
	{
		ErrorMessage();
	}

}

void CVCSampleDlg::OnButtonGetUniqueidslist() 
{
	CString sUniqueId = "";
	
	m_sListRegisteredClients.ResetContent();
	
	for(int nIndex = 0;; nIndex++)
	{
		sUniqueId = m_pConaitoServer->GetRegisteredClientAt(nIndex);
		
		if(sUniqueId == "") break;

		m_sListRegisteredClients.AddString(sUniqueId);
	}
	
}
